import sys
sys.path.append('../zerosumset')
import pytest


from zerosumset import zerosumset
from zerosumset import maxzerosumset
from itertools import groupby


test_cases = [-7, -3, -2, 9000, 5, 8]

test_cases_identical = [[], [1, 2, -3], [0]]


@pytest.mark.parametrize("elems", test_cases)
def test_zerosumset(elems):
    output = zerosumset(elems)
    assert output == elems, f"Failed: expected {elems}"

@pytest.mark.parametrize("elems", test_cases)
def test_maxzerosumset_len(elems):
    output = maxzerosumset(elems)
    normal_output = zerosumset(elems)
    assert output >= normal_output, f"Something is wrong"

@pytest.mark.parametrize("elems", test_cases)
def test_maxzerosumset_zeros(elems):
    a = 0;
    output = maxzerosumset(elems)
    for i in range(elems):
        if elems[i] == 0:
            a = a +1
    for i in range(output):
        if output[i]==0:
            a = a -1
    assert a == 0, f"Something is wrong"

@pytest.mark.parametrize("elems", test_cases)
def test_maxzerosumset_same_number(elems):
    a = 0;
    output = maxzerosumset(elems)
    sort_elems = sorted(elems)
    new = [len(list(group)) for key, group in groupby(sort_elems)]
    for i in range(new):
        if new[i] > 1:
            a = a + i - i%2
    assert a <= len(output), f"Something is wrong"


